package com.clx.performance.service.impl.settle;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.clx.performance.dao.settle.SettlementDriverDao;
import com.clx.performance.dao.settle.SettlementDriverDetailDao;
import com.clx.performance.model.settle.SettlementDriver;
import com.clx.performance.model.settle.SettlementDriverDetail;
import com.clx.performance.param.pc.driver.PageCarrierSettlementDriverParam;
import com.clx.performance.service.settle.SettlementDriverService;
import com.clx.performance.struct.settle.SettlementDriverStruct;
import com.clx.performance.vo.pc.carrier.settle.CarrierPageSettlementDriverVO;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;

/**
 * @author liruixin
 * Date 2023-10-12
 * Time 09:43
 */
@Service
@AllArgsConstructor
public class SettlementDriverServiceImpl implements SettlementDriverService {


    SettlementDriverDao settlementDriverDao;
    SettlementDriverStruct settlementDriverStruct;


    private final SettlementDriverDetailDao settlementDriverDetailDao;

    @Override
    public void saveSettlement(SettlementDriverDetail settlementDetail) {

        SettlementDriver settlementDriver = new SettlementDriver();

        settlementDriver.setSettlementNo("");
        settlementDriver.setDriverUserNo(settlementDetail.getDriverUserNo());
        settlementDriver.setDriverName(settlementDetail.getDriverName());
        settlementDriver.setTruckNo(settlementDetail.getTruckNo());

        settlementDriver.setChildNo(settlementDetail.getChildNo());
        settlementDriver.setOrderGoodsNo(settlementDetail.getOrderGoodsNo());
        settlementDriver.setOrderNo(settlementDetail.getOrderNo());

        settlementDriver.setGoodsId(settlementDetail.getGoodsId());
        settlementDriver.setGoodsName(settlementDetail.getGoodsName());

        settlementDriver.setFreightPrice(settlementDetail.getFreightPrice());
        settlementDriver.setWeight(settlementDetail.getWeight());
        settlementDriver.setFreight(settlementDetail.getFreight());
        settlementDriver.setLossPrice(settlementDetail.getLossPrice());
        settlementDriver.setLossWeight(settlementDetail.getLossWeight());
        settlementDriver.setLossFreight(settlementDetail.getLossFreight());

        settlementDriver.setSettlementFreight(BigDecimal.ZERO);

        settlementDriver.setSettlementPlatform("");

        settlementDriver.setInvoiceType(settlementDetail.getInvoiceType());

        settlementDriverDao.saveEntity(settlementDriver);

    }

    @Override
    public IPage<CarrierPageSettlementDriverVO> pageCarrierSettlementDriver(PageCarrierSettlementDriverParam param) {
        IPage<SettlementDriver> page = settlementDriverDao.pageCarrierSettlementDriver(param);
        List<CarrierPageSettlementDriverVO> list = settlementDriverStruct.covertList(
                page.getRecords());
        IPage<CarrierPageSettlementDriverVO> result = new Page().setRecords(list).setTotal(page.getTotal()).setPages(page.getPages());
        return result;
    }
}
